import java.io.*;
import java.util.*;

public class School {

	Scanner in;
	PrintWriter out;
	
	long w1[];
	long w2[];
	
	long remainedSum1[];
	long remainedSum2[];
	
	int bestChanges = Integer.MAX_VALUE / 2;
	
	int gen(long c1, long c2, int idx1, int idx2, int changes) {
		if (changes >= bestChanges) {
			return Integer.MAX_VALUE / 2;
		}
		if (c1 == c2) {
			return changes;
		}
		if (idx1 == w1.length || idx2 == w2.length) {
			return Integer.MAX_VALUE / 2;
		}
		if (c1 - remainedSum1[idx1] > c2) {
			return Integer.MAX_VALUE / 2;
		}
		if (c2 - remainedSum2[idx2] > c1) {
			return Integer.MAX_VALUE / 2;
		}
		int x1 = gen(c1, c2, idx1 + 1, idx2, changes);
		int x2 = gen(c1, c2, idx1, idx2 + 1, changes);
		int x3 = gen(c1 - w1[idx1], c2, idx1 + 1, idx2, changes + 1);
		int x4 = gen(c1, c2 - w2[idx2], idx1, idx2 + 1, changes + 1);
		return Math.min(Math.min(x1, x2), Math.min(x3, x4));
	}
	
	long sum(long []v) {
		long a = 0;
		for (long x : v) {
			a += x;
		}
		return a;
	}
	
	long [] read(int size) {
		long []v = new long[size];
		for (int i = 0; i < v.length; i++) {
			v[i] = in.nextInt();
		}
		Arrays.sort(v);
		for (int i = 0; i < v.length - 1 - i; i++) {
		    long t = v[v.length - 1 - i];
		    v[v.length - 1 - i] = v[i];
		    v[i] = t;
		}
		return v;
	}
	
	long [] rsum(long []a) {
		long []rs = new long [a.length];
		rs[rs.length - 1] = a[a.length - 1];
		for (int i = rs.length - 2; i >= 0; i--) {
			rs[i] = rs[i + 1] + a[i];
		}
		return rs;
	}
	
	void solve() {
		int first = in.nextInt();
		int second = in.nextInt();
		
		w1 = read(first);
		w2 = read(second);
		
		remainedSum1 = rsum(w1);
		remainedSum2 = rsum(w2);
		
		out.println(gen(sum(w1), sum(w2), 0, 0, 0));
	}
	
	void run() {
	    try{
     		in = new Scanner(new FileReader("balance.in"));
    		out = new PrintWriter(new FileWriter("balance.out"));
    	} catch(IOException e) {
    	    throw new Error();
    	}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String args[]) {
		new School().run();
	}
}
