#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>

std::vector<int> w;

std::map<long long, int> genAllSums(int l, int r) {
  std::map<long long, int> sums;

  // вначале все вычеркнуты
  std::vector<int> mask(r + 2, 0);
  int cost = r - l + 1; 
  sums[0] = cost;
  int sum = 0;

  // полный перебор вариантов
  while (true) {
    int i = l;
    while (mask[i] == 1) {
      mask[i] = 0;
      cost++;
      sum -= w[i];
      i++;
    }
    if (i > r) {
      break;
    }
    mask[i] = 1;
    cost--;
    sum += w[i];
    std::map<long long, int> :: iterator it = sums.find(sum);
    if (it == sums.end() || it->second > cost) {
      sums[sum] = cost;
    }
  }

  return sums;
}


int main() {
  freopen("balance.in", "rt", stdin);
  freopen("balance.out", "wt", stdout);  
  int l, r;
  scanf("%d %d", &l, &r);
  int n = l + r;
  w.resize (n);
  for (int i = 0; i < l + r; i++) {
    scanf("%d", &w[i]);
    if (i < l) {
      w[i] = -w[i];
    }
  }
  int mid = n / 2;
  std::map<long long, int> sl = genAllSums(0, mid);
  std::map<long long, int> sr = genAllSums(mid + 1, n - 1);

  int answer = l + r;
  for (std::map<long long, int> :: iterator it = sl.begin(); it != sl.end(); it++) {
    std::map<long long, int> :: iterator it2 = sr.find(-it->first);
    if (it2 != sr.end()) {
      answer = std::min(answer, it->second + it2->second);
    }
  }
  printf("%d", answer);

  return 0;
}

// ! сделать тесты на переполнение int
