import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Scanner;

public class Main {

    private Scanner in;

    private void solve(PrintWriter out) {
        int nRecords = in.nextInt();
        int timeoutMS = in.nextInt() * 1000;
        int time[] = new int[nRecords];
        in.nextLine();
        for (int i = 0; i < nRecords; i++) {
            String timeSt = in.nextLine();
            time[i] = getTime(timeSt);
        }
        for (int logTimeStart = time[0] - timeoutMS; logTimeStart < time[0]; logTimeStart++) {
            int nextRecordIdx = 0;
            for (int logTime = logTimeStart; logTime <= time[time.length - 1] + timeoutMS; logTime += timeoutMS) {
                if (time[nextRecordIdx] < logTime) {
                    nextRecordIdx++;
                    if (nextRecordIdx == nRecords) {
                        break;
                    }
                    if (time[nextRecordIdx] < logTime) {
                        break;
                    }
                }
            }
            if (nextRecordIdx == nRecords) {
                out.println("It seems everything is fine");
                //System.out.println("logTimeStart = " + getTime(logTimeStart));
                return;
            }
        }
        out.println("Strange behavior detected");
    }

    private String getTime(int millis) {
        return String.format("%02d:%02d:%02d.%03d", millis / 60 / 60 / 1000, millis / 60 / 1000 % 60, millis / 1000 % 60, millis % 1000);
    }

    private int getTime(String time) {
        int hour = Integer.parseInt(time.substring(0, 2));
        int min = Integer.parseInt(time.substring(3, 5));
        int sec = Integer.parseInt(time.substring(6, 8));
        int millis = Integer.parseInt(time.substring(9, 12));
        return millis + sec * 1000 + min * 60 * 1000 + hour * 60 * 60 * 1000;
    }

    public void run() {
        try (PrintWriter out = new PrintWriter("cats.out")) {
            in = new Scanner(new FileReader("cats.in"));
            solve(out);
        } catch (Exception e) {
            throw new Error(e);
        }
    }


    public static void main(String[] args) {
        new Main().run();
    }
}