import java.io.*;
import java.util.*;
import java.util.Map.Entry;

public class Main {

	Scanner in;

	PrintWriter out;

	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}

	static void asserT(boolean e, String s) {
		if (!e) {
			throw new Error(s);
		}
	}

	long gcd(long a, long b) {
		if (b == 0) {
			return a;
		} else {
			return gcd(b, a % b);
		}
	}

	void found(long a, long b, long c, long x, long y) {
		// out.println(a + "*" + x + " + "+ b + "*" + y + " = " + c);

		asserT((c - y * b) % a == 0);
		long period = a / gcd(a, b);

		long minSum = Long.MAX_VALUE;
		for (long i = -1000000; i < 1000000; i++) {
			long newY = (y + period * i);
			long newX = (c - newY * b) / a;
			if (newX * a + newY * b == c) {
				minSum = Math.min(minSum, Math.abs(newY) + Math.abs(newX));
			}
		}
		out.println(minSum);
	}

	long mod(long div, long modulo) {
		return (div % modulo + modulo) % modulo;
	}

	void solve2() {
		long a = in.nextLong();
		long b = in.nextLong();
		long c = Math.abs(in.nextLong());
		long div = gcd(gcd(a, b), c);

		a /= div;
		b /= div;
		c /= div;

		long first = c / b;
		long rem1 = mod(c - first * b, a);
		long rem2 = mod(c - (1+first) * b, a);
		long diff = mod(rem2 - rem1, a);

		long right = mod(-rem1, a);

		Long val = solveEq(diff, right, a);
		if (val == null) {
			out.println(-1);
		} else {
//			out.println(val);
			val += first;
			asserT(mod(c - b * val, a) == 0);
			
			long bx = val;

			long ax = (c - bx * b) / a;
			asserT(a * ax + b * bx == c, a + " * " + ax + " + " + b + " * " + bx + " == " + c);

			found(a, b, c, ax, bx);
		}
	}

	Long solveEq(long a, long b, long m) {
		long d = gcd(a, m);
		if (b % d == 0) {
			a /= d;
			b /= d;
			m /= d;
			return mod(recip(a, m) * b , m);
		} else {
			return null;
		}
	}

	long phi(long m) {
		if (m == 1) {
			return 1;
		}
		long init = m;
		Map<Integer, Integer> divisors = new HashMap<>();
		for (int i = 2; i * i <= m; i++) {
			int nDiv = 0;
			while (m % i == 0) {
				m /= i;
				nDiv++;
			}
			if (nDiv != 0) {
				divisors.put(i, nDiv);
			}
		}
		if (m != 1) {
			divisors.put((int)m, 1);
		}
		if (divisors.size() == 1) {
//			out.println("phi(" + init + ") = " + (init - 1));
			return init - 1;
		}
		long res = 1L;
		for (Entry<Integer, Integer> pow : divisors.entrySet()) {
			if (pow.getValue() == 1) {
				res = res * (pow.getKey() - 1);
			} else {
				long power = pow(pow.getKey(), pow.getValue(), init);
				long pm1 = pow(pow.getKey(), pow.getValue() - 1, init);
				res = res * (power - pm1);
			}
		}
//		out.println("phi(" + init + ") = " + res);
		return res;
	}
	
	long pow(long x, long p, final long mudilo) {
		if (x <= 1) {
			return x % mudilo;
		}
		if (p == 1) {
			return x;
		}
		if (p == 0) {
			return 1;
		}
		if (p % 2 == 0) {
			long p2 = pow(x, p / 2, mudilo);
			return mod(p2 * p2, mudilo);
		} else {
			long p2 = pow(x, p - 1, mudilo);
			return mod(x * p2, mudilo);
		}
	}

	long recip(long a, long m) {
		return pow(a, phi(m) - 1, m);
	}

	void run() {
	    try {
    		in = new Scanner(new FileReader("hare.in"));
	    	out = new PrintWriter(new FileWriter("hare.out"));
	    } catch (IOException e) {
     	    throw new Error();
	    }

		try {
			solve2();
		} finally {
			out.close();
		}
	}

	public static void main(String args[]) {
		new Main().run();
	}
}
