#include <iostream>
#include <cstdio>

long long gcd (long long a, long long b, long long &x, long long &y) {
  if (a == 0) {
    x = 0; 
    y = 1;
    return b;
  }
  long long x1, y1;
  long long d = gcd (b % a, a, x1, y1);
  x = y1 - (b / a) * x1;
  y = x1;
  return d;
}

int main() {
  freopen("hare.in", "rt", stdin);
  freopen("hare.out", "wt", stdout);

  long long a, b, c;
  std::cin >> a >> b >> c;
  if (c < 0) {
    c = -c;
  }
  long long xg, yg;
  long long g = gcd(a, b, xg, yg);
  if (c % g != 0) {
    std::cout << -1;
    return 0;
  }
  // начальное решение уравнения
  long long x0 = xg * (c / g);
  long long y0 = yg * (c / g);

  long long answer = -1;
  long long bg = b / g;
  long long ag = a / g;

  // ----- случай 1: x >= 0, y >= 0 -----
  // находим наименьшее k, при котором x >= 0
  long long kmin = -x0 / bg;
  if (kmin * bg != -x0 && -x0 > 0) {
    kmin++;
  }
  // находим наибольшее k, при котором y >= 0
  long long kmax = y0 / ag;
  if (kmax * ag != y0 && y0 < 0) {
    kmax--;
  }
  // нам нужно как можно меньшее значение k
  if (kmax >= kmin) {
    answer = x0 + kmin * bg + y0 - kmin * ag;
  }

  // ----- случай 2: x >= 0, y <= 0 -----
  // k >= kmin, k > kmax
  // x - y = x0 - y0 + k * ((b + a) / g) отсюда k как можно меньше
  long long k2 = std::max(kmin, kmax + 1);
  long long ans = x0 + k2 * bg - y0 + k2 * ag;
  if (answer < 0 || ans < answer) {
    answer = ans;
  }

  // ----- случай 3: x <= 0, y >= 0 -----
  // k < kmin, k >= kmax
  // y - x  = y0 - x0 - k * ((b + a) / g) отсюда k как можно больше
  long long k3 = std::min(kmin - 1, kmax);
  ans = y0 - k3 * ag - x0 - k3 * bg;
  if (answer < 0 || ans < answer) {
    answer = ans;
  }

  std::cout << answer;
  return 0;
}
