{$APPTYPE CONSOLE}
program CheckSpiral;
uses
  SysUtils, testlib, math;
const
 NMAX=10000;
type
 Coord=record
  x,y:int64;
 end;
 Line=record
  a,b,c:int64;
 end; 
var
 N1,N2:longint;
 M1:array[1..NMAX] of Coord;
 M2:array[1..NMAX] of longint;
 i,j,x,y:longint;
 PD:array[1..NMAX] of longint;
 PDsum:int64;
 X1,Y1,X2,Y2,D:int64;
 angle:extended;
 OTR:array[1..NMAX-1] of Line;
 pf:longint;
 xp,yp:extended;
begin
 N1:=inf.readlongint;
 for i:=1 to N1 do begin
  X:=inf.readlongint;
  Y:=inf.readlongint;
  M1[i].x:=X;M1[i].y:=Y;
 end;
 //Length
 N2:=ouf.readlongint;
 if (N2<>N1) then QUIT(_WA,'Invalid length!');
 for i:=1 to N2 do M2[i]:=ouf.readlongint;
 //Points numbers
 fillchar(PD[1],sizeof(PD),0);
 for i:=1 to N2 do begin
  if (M2[i]<1) or (M2[i]>N2) then QUIT(_WA,'Invalid point number! '+inttostr(M2[i]));
  PD[M2[i]]:=1;
 end; 
 PDsum:=0;
 for i:=1 to N2 do PDsum:=PDsum+PD[i];
 if PDsum<>N2 then QUIT(_WA,'Invalid point number!');
 //Angels
 for i:=2 to N2-1 do begin
  X1:=M1[M2[i]].x-M1[M2[i-1]].x;
  Y1:=M1[M2[i]].y-M1[M2[i-1]].y;
  X2:=M1[M2[i+1]].x-M1[M2[i]].x;
  Y2:=M1[M2[i+1]].y-M1[M2[i]].y;
  angle:=arctan2(X1*Y2-X2*Y1,X1*X2+Y1*Y2);
  if (angle>0) or (angle=-pi) then QUIT(_WA,'Invalid angle! '+inttostr(M2[i-1])+'-'+inttostr(M2[i])+' with '+inttostr(M2[i])+'-'+inttostr(M2[i+1]));
 end;
 //Crosspoints 
 for i:=1 to N2-1 do begin
  OTR[i].a:=M1[M2[i]].y-M1[M2[i+1]].y;
  OTR[i].b:=M1[M2[i+1]].x-M1[M2[i]].x;
  OTR[i].c:=M1[M2[i]].x*M1[M2[i+1]].y-M1[M2[i+1]].x*M1[M2[i]].y;
 end;
 for i:=1 to N2-3 do begin
  for j:=i+2 to N2-1 do begin
   pf:=0;
   if (OTR[i].b<>0) and (OTR[j].b<>0) then begin
    D:=OTR[i].a*OTR[j].b-OTR[j].a*OTR[i].b;
    if D=0 then begin
     if ((OTR[i].c/OTR[i].b)=(OTR[j].c/OTR[j].b)) and (max(M1[M2[i]].x,M1[M2[j]].x)<=min(M1[M2[i+1]].x,M1[M2[j+1]].x)) then
      QUIT(_WA,'Crosspoint! '+inttostr(M2[i])+'-'+inttostr(M2[i+1])+' with '+inttostr(M2[j])+'-'+inttostr(M2[j+1]));
    end
    else begin
     xp:=extended(0.0+OTR[i].b*OTR[j].c-OTR[i].c*OTR[j].b)/D;
     yp:=extended(0.0+OTR[j].a*OTR[i].c-OTR[i].a*OTR[j].c)/D;
     pf:=1;
    end;
   end
   else begin
    if OTR[i].b<>0 then begin
     xp:=-OTR[j].c/OTR[j].a;
     yp:=(-OTR[i].a*xp-OTR[i].c)/OTR[i].b;
     pf:=1;
    end
    else begin
     if OTR[j].b<>0 then begin
      xp:=-OTR[i].c/OTR[i].a;
      yp:=(-OTR[j].a*xp-OTR[j].c)/OTR[j].b; 
      pf:=1;
     end
     else begin
      if ((OTR[i].c/OTR[i].a)=(OTR[j].c/OTR[j].a)) and (max(M1[M2[i]].y,M1[M2[j]].y)<=min(M1[M2[i+1]].y,M1[M2[j+1]].y)) then 
       QUIT(_WA,'Crosspoint on vertical segments! '+inttostr(M2[i])+'-'+inttostr(M2[i+1])+' with '+inttostr(M2[j])+'-'+inttostr(M2[j+1]));
     end;
    end; 
   end;
   if pf=1 then begin
    if (xp>=min(M1[M2[i]].x,M1[M2[i+1]].x)) and (xp<=max(M1[M2[i]].x,M1[M2[i+1]].x)) and (xp>=min(M1[M2[j]].x,M1[M2[j+1]].x)) and (xp<=max(M1[M2[j]].x,M1[M2[j+1]].x)) and
     (yp>=min(M1[M2[i]].y,M1[M2[i+1]].y)) and (yp<=max(M1[M2[i]].y,M1[M2[i+1]].y)) and (yp>=min(M1[M2[j]].y,M1[M2[j+1]].y)) and (yp<=max(M1[M2[j]].y,M1[M2[j+1]].y)) then
     QUIT(_WA,'Crosspoint! '+inttostr(M2[i])+'-'+inttostr(M2[i+1])+' with '+inttostr(M2[j])+'-'+inttostr(M2[j+1]));
   end;
  end;
 end;
 QUIT(_OK,'OK!');
end.
