#include <cstdio>
#include <vector>

struct Point {

  int x, y;

  bool used;
};

int main() {
  freopen("spiral.in", "rt", stdin);
  freopen("spiral.out", "wt", stdout);
  int n;
  scanf("%d", &n);
  std::vector<Point> p(n);
  for (int i = 0; i < n; i++) {
    scanf("%d %d", &p[i].x, &p[i].y);
    p[i].used = false;
  }
  
  int first = 0;
  for (int i = 1; i < n; i++) {
    if (p[i].y < p[first].y || p[i].y == p[first].y && p[i].x < p[first].x) {
      first = i;
    }
  }

  std::vector<int> ans;
  ans.push_back(first);
  p[first].used = true;

  for (int k = 2; k <= n; k++) {

    int second = -1;

    for (int i = 0; i < n; i++) {
      if (p[i].used) continue;
      if (second < 0) {
        second = i;
        continue;
      }
      // a: first -> i, b: first->second
      int ax = p[i].x - p[first].x;
      int ay = p[i].y - p[first].y;
      int bx = p[second].x - p[first].x;
      int by = p[second].y - p[first].y;
      int mult = ax * by - ay * bx;
      if (mult > 0) {
        second = i;
      } else if (mult == 0) {
        int da2 = ax * ax + ay * ay;
        int db2 = bx * bx + by * by;
        if (da2 < db2) {
          second = i;
        }
      }
    }                          

    ans.push_back(second);
    p[second].used = true;
    first = second;
  }

  printf("%d\n", n);
  for (int i = n - 1; i >= 0; i--) {
    printf("%d", ans[i] + 1);
    if (i > 0) {
      putchar(' ');
    }
  }
  
  return 0;
}
