import java.io.*;
import java.util.*;
import java.math.*;

class Main {

	long slow(long n) {
		long count = 0;
		for (long a = 1; a <= n / 4; a++) {
			for (long b = a; b <= (n - a) / 3; b++) {
				for (long c = b; c <= (n - a - b) / 2; c++) {
					count++;
				}
			}
		}
		return count;
	}

	BigInteger big(long value) {
		return BigInteger.valueOf(value);
	}

	BigInteger fast(long n) {
		long n1 = n % 12;
		long n2 = n1 + 12;
		long n3 = n2 + 12;
		long n4 = n3 + 12;
		long f1 = slow(n1);
		long f2 = slow(n2);
		long f3 = slow(n3);
		long f4 = slow(n4);
		long d12 = f2 - f1;
		long d23 = f3 - f2;
		long d43 = f4 - f3;
		long dd13 = d23 - d12;
		long dd24 = d43 - d23;
		long ddd14 = dd24 - dd13;
		// f1
		// + d12 * (n - n1) / (n2 - n1)
		// + dd13 * (n - n1) * (n - n2) / (n3 - n1) / (n3 - n2)
		// + ddd14 * (n - n1) * (n - n2) * (n - n3) / (n4 - n1) / (n4 - n2) / (n4 - n3)
		return
			big(f1)
			.add(big(d12).multiply(big(n - n1)).divide(big(n2 - n1)))
			.add(big(dd13).multiply(big(n - n1)).multiply(big(n - n2)).divide(big(n3 - n1)).divide(big(n3 - n2)))
			.add(big(ddd14).multiply(big(n - n1)).multiply(big(n - n2)).multiply(big(n - n3)).divide(big(n4 - n1)).divide(big(n4 - n2)).divide(big(n4 - n3)));
	}

	void solve(Scanner in, PrintWriter out) {
		long n = in.nextLong();
		out.println(fast(n));
	}

	void selfTest() {
		for (int i = 1; i <= 100; i++) {
			String slowAns = "" + slow(i);
			String fastAns = "" + fast(i);
			if (slowAns.compareTo(fastAns) != 0) {
				throw new Error("wrong for i = " + i);
			}
		}
	}
	
	void run() {
		selfTest();
		try (
			Scanner in = new Scanner(new FileReader("sumof4.in"));
			PrintWriter out = new PrintWriter(new FileWriter("sumof4.out"));
		) {
			solve(in, out);
		} catch (IOException e) {
			throw new Error(e);
		}
	}

	public static void main(String args[]) {
		new Main().run();
	}
}
