import java.io.*;
import java.util.*;

public class Main {

    BufferedReader in;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        new Main().run();
    }

    public void run() throws IOException {
            try{
        in = new BufferedReader(new FileReader("twofold.in"));
        out = new PrintWriter("twofold.out");
        }    
            catch (IOException e) {
                throw new Error();
            }

        try {
            solve();
        } finally {
            out.close();
        }
    }

    public void solve() throws IOException {
             int n = Integer.parseInt(in.readLine());
         for (int i = 0; i < n; i++) {
             solve(in.readLine());
         }
    }

    StringBuilder makeTwofold(String x, boolean hi) {      
      StringBuilder s = new StringBuilder(x);
      char a = 0, b = 0;
      int countA = 0, countB = 0, firstA = -1, firstB =-1, lastA = -1, lastB = -1;
      int i;
      for (i = 0; i < s.length(); i++) {
        char c = s.charAt(i);
        if (c == a) { 
          countA++; 
          lastA = i;
          continue; 
        }
        if (c == b) { 
          countB++; 
          lastB = i;
          continue; 
        }
        if (a != 0 && b != 0)  break;
        if (a == 0)  {
          a = c; 
          countA = 1;
          firstA = i;
          lastA = i;
        } else { 
          b = c; 
          countB = 1; 
          firstB = i;
          lastB = i;
        }
      }
      if (a > b) {
        char cTmp = a; a = b; b = cTmp;
        int iTmp = countA; countA = countB; countB = iTmp;
        iTmp  = firstA; firstA = firstB; firstB = iTmp;
        iTmp  = lastA; lastA = lastB; lastB = iTmp;
      }
      if (i == s.length()) {
        return s;
      }
      if (hi) {
        return makeHiTwofold(s, a, countA, firstA, lastA, b, countB, firstB, lastB, i);
      } else {
        return makeLoTwofold(s, a, countA, firstA, lastA, b, countB, firstB, lastB, i);
      }
    }

    StringBuilder makeHiTwofold(StringBuilder s, char a, int aCount, int aFirst, int aLast, char b, int bCount, int bFirst, int bLast, int pos) {
      char c = s.charAt(pos);
      
      if (c < a) {
        for (int i = pos; i < s.length(); i++) {
          s.setCharAt(i, a);
        }
      }

      else if (c < b) {
        s.setCharAt(pos, b);
        for (int i = pos + 1; i < s.length(); i++) {
          s.setCharAt(i, a);
        }        
      }

      else {
        char x = a, y = b;
        int xCount = aCount, xFirst = aFirst, xLast = aLast;
        int yCount = bCount, yFirst = bFirst, yLast = bLast;
        if (s.charAt(0) == x) {
          x = b; y = a;
          xCount = bCount; xFirst = bFirst; xLast = bLast;
          yCount = aCount; yFirst = aFirst; yLast = aLast;
        }
        if (x + 1 == y) {
          s.setCharAt(xLast, (char)(x + 1));
          char r = (xCount == 1) ? '0' : x;
          for (int i = xLast + 1; i < s.length(); i++) {
            s.setCharAt(i, r);
          }
        } else if (y + 1 == x && xFirst < yLast) {
          s.setCharAt(yLast, x);
          for (int i = yLast + 1; i < s.length(); i++) {
            s.setCharAt(i, y);
          }
        }        
        else {
          s.setCharAt(xFirst, (char)(x + 1));
          char r = (char)Math.min(x + 1, y);
          for (int i = xFirst + 1; i < s.length(); i++) {
            s.setCharAt(i, r);
          }
        }
      }

      return s;
    }

    StringBuilder makeLoTwofold(StringBuilder s, char a, int aCount, int aFirst, int aLast, char b, int bCount, int bFirst, int bLast, int pos) {
      char c = s.charAt(pos);
      
      if (c > b) {
        for (int i = pos; i < s.length(); i++) {
          s.setCharAt(i, b);
        }
      }

      else if (c > a) {
        s.setCharAt(pos, a);
        for (int i = pos + 1; i < s.length(); i++) {
          s.setCharAt(i, b);
        }        
      }

      else {
        char x = a, y = b;
        int xCount = aCount, xFirst = aFirst, xLast = aLast;
        int yCount = bCount, yFirst = bFirst, yLast = bLast;
        if (s.charAt(0) == x) {
          x = b; y = a;
          xCount = bCount; xFirst = bFirst; xLast = bLast;
          yCount = aCount; yFirst = aFirst; yLast = aLast;
        }
        if (x - 1 == y) {
          s.setCharAt(xLast, (char)(x - 1));
          char r = (xCount == 1) ? '9' : x;
          for (int i = xLast + 1; i < s.length(); i++) {
            s.setCharAt(i, r);
          }
        } else if (y - 1 == x && xFirst < yLast) {
          s.setCharAt(yLast, x);
          for (int i = yLast + 1; i < s.length(); i++) {
            s.setCharAt(i, y);
          }
        }        
        else {
          s.setCharAt(xFirst, (char)(x - 1));
          char r = (char)Math.max(x - 1, y);
          for (int i = xFirst + 1; i < s.length(); i++) {
            s.setCharAt(i, r);
          }
        }
      }

      return s;
    }

    StringBuilder add (StringBuilder a, StringBuilder b) {
      int rem = 0;
      for (int i = a.length() - 1; i >= 0; i--) {
        rem = rem + a.charAt(i) - '0' + b.charAt(i) - '0';
        a.setCharAt(i, (char)(rem % 10 + '0'));
        rem /= 10;
      }
      return a;
    }

    boolean less(StringBuilder a, StringBuilder b) {
      for (int i = 0; i < a.length(); i++) {
        if (a.charAt(i) < b.charAt(i)) {
          return true;
        }
        if (a.charAt(i) > b.charAt(i)) {
          return false;
        }
      }
      return false;
    }

    public void solve(String s) {
      StringBuilder hi = makeTwofold(s, true);
      String h = hi.toString();
      StringBuilder lo = makeTwofold(s, false);
      StringBuilder ss = new StringBuilder(s);
      if (less( add(hi, lo), add(ss, ss)) ) {
        out.println(h);
      } else {
        out.println(lo);
      }
    }
}
