import java.io.*;
import java.util.*;
import java.math.*;

class Main {

	static class Assert {
		static void check(boolean e) {
			if (!e) {
				throw new Error();
			}
		}
	}

	BigInteger c[][] = new BigInteger[1001][1001];
	
	BigInteger c(int n, int k) {
		if (k == 0 || k == n) {
			return BigInteger.ONE;
		} else {
			if (c[n][k] == null) {
				c[n][k] = c(n - 1, k).add(c(n - 1, k - 1));
			}
			return c[n][k];
		}
	}

	void solve(Scanner in, PrintWriter out) {
		String line = in.next();
		int letterCount[] = new int[1 + 'z'];
		for (char c : line.toCharArray()) {
			Assert.check('a' <= c && c <= 'z');
			letterCount[c]++;
		}
		BigInteger wordCountForLen[] = new BigInteger[1 + line.length()];
		Arrays.fill(wordCountForLen, BigInteger.ZERO);
		wordCountForLen[0] = BigInteger.ONE;
		for (char c = 'a'; c <= 'z'; c++) {
			if (letterCount[c] != 0) {
				BigInteger prevWordCountForLen[] = wordCountForLen.clone();
				for (int wordLen = 0; wordLen <= line.length(); wordLen++) {
					for (int lastLetterCount = 1; lastLetterCount <= letterCount[c] && lastLetterCount <= wordLen; lastLetterCount++) {
						wordCountForLen[wordLen] = wordCountForLen[wordLen].add(prevWordCountForLen[wordLen - lastLetterCount].multiply(c(wordLen, lastLetterCount)));
					}
				}
			}
		}
		BigInteger sum = BigInteger.ZERO;
		for (int i = 1; i <= line.length(); i++) {
			sum = sum.add(wordCountForLen[i]);
		}
		out.println(sum);
	}

	void run() {
		try (
			Scanner in = new Scanner(new FileReader("typesetter.in"));
			PrintWriter out = new PrintWriter(new FileWriter("typesetter.out"));
		) {
			solve(in, out);
		} catch (IOException e) {
			throw new Error(e);
		}
	}

	public static void main(String args[]) {
		new Main().run();
	}
}
